# connection-restapi-client-poc
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 24.0.5.0987
- Generator version: 7.9.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import connection_restapi_client_poc
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import connection_restapi_client_poc
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import connection_restapi_client_poc
from connection_restapi_client_poc.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = connection_restapi_client_poc.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with connection_restapi_client_poc.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = connection_restapi_client_poc.CalculationApi(api_client)
    project_id = 'project_id_example' # str | The unique identifier of the opened project in the ConnectionRestApi service
    con_calculation_parameter = connection_restapi_client_poc.ConCalculationParameter() # ConCalculationParameter | List of connections to calculate and a type of CBFEM analysis (optional)

    try:
        # Run CBFEM caluclation and return the summary of the results
        api_response = api_instance.calculate(project_id, con_calculation_parameter=con_calculation_parameter)
        print("The response of CalculationApi->calculate:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling CalculationApi->calculate: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CalculationApi* | [**calculate**](docs/CalculationApi.md#calculate) | **POST** /api/1/projects/{projectId}/calculate | Run CBFEM caluclation and return the summary of the results
*CalculationApi* | [**get_raw_json_results**](docs/CalculationApi.md#get_raw_json_results) | **POST** /api/1/projects/{projectId}/rawresults-text | Get json string which represents raw CBFEM results (an instance of CheckResultsData)
*CalculationApi* | [**get_results**](docs/CalculationApi.md#get_results) | **POST** /api/1/projects/{projectId}/results | Get detailed results of the CBFEM analysis
*ConnectionApi* | [**delete_operations**](docs/ConnectionApi.md#delete_operations) | **DELETE** /api/1/projects/{projectId}/connections/{connectionId}/operations | Delete all operations for the connection
*ConnectionApi* | [**get_all_connections_data**](docs/ConnectionApi.md#get_all_connections_data) | **GET** /api/1/projects/{projectId}/connections | Get data about all connections in the project
*ConnectionApi* | [**get_connection_data**](docs/ConnectionApi.md#get_connection_data) | **GET** /api/1/projects/{projectId}/connections/{connectionId} | Get data about a specific connection in the project
*ConnectionApi* | [**get_missing_welds**](docs/ConnectionApi.md#get_missing_welds) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/missing-welds | Get missing welds in the connection
*ConnectionApi* | [**get_operations**](docs/ConnectionApi.md#get_operations) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/operations | Get the list of operations for the connection
*ConnectionApi* | [**get_production_cost**](docs/ConnectionApi.md#get_production_cost) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/production-cost | Get production cost of the connection
*ConnectionApi* | [**update_connection_data**](docs/ConnectionApi.md#update_connection_data) | **PUT** /api/1/projects/{projectId}/connections/{connectionId} | Update data of a specific connection in the project
*ExportApi* | [**export_connection_data**](docs/ExportApi.md#export_connection_data) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/export-iom-connection-data | Get https://github.com/idea-statica/ideastatica-public/blob/main/src/IdeaRS.OpenModel/Connection/ConnectionData.cs for required connection
*ExportApi* | [**export_connection_ifc**](docs/ExportApi.md#export_connection_ifc) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/export-ifc | Export connection to IFC format
*ExportApi* | [**export_iom_xml**](docs/ExportApi.md#export_iom_xml) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/export-iom | Export connection to XML which includes https://github.com/idea-statica/ideastatica-public/blob/main/src/IdeaRS.OpenModel/OpenModelContainer.cs
*LoadEffectApi* | [**add_load_effect**](docs/LoadEffectApi.md#add_load_effect) | **POST** /api/1/projects/{projectId}/connections/{connectionId}/load-effects | Add new load effect to the connection
*LoadEffectApi* | [**delete_load_effect**](docs/LoadEffectApi.md#delete_load_effect) | **DELETE** /api/1/projects/{projectId}/connections/{connectionId}/load-effects/{loadEffectId} | Delete load effect loadEffectId
*LoadEffectApi* | [**get_load_effect**](docs/LoadEffectApi.md#get_load_effect) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/load-effects/{loadEffectId} | Get load impulses from loadEffectId
*LoadEffectApi* | [**get_load_effects**](docs/LoadEffectApi.md#get_load_effects) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/load-effects | Get all load effects which are defined in connectionId
*LoadEffectApi* | [**set_loads_in_equilibrium**](docs/LoadEffectApi.md#set_loads_in_equilibrium) | **POST** /api/1/projects/{projectId}/connections/{connectionId}/load-effects/set-equilibrium | Update the option &#39;LoadsInEquilibrium&#39; for connectionId
*LoadEffectApi* | [**update_load_effect**](docs/LoadEffectApi.md#update_load_effect) | **PUT** /api/1/projects/{projectId}/connections/{connectionId}/load-effects/{loadEffectId} | Update load impulses in loadEffectId
*MaterialApi* | [**add_bolt_assembly**](docs/MaterialApi.md#add_bolt_assembly) | **POST** /api/1/projects/{projectId}/materials/bolt-assemblies | Add bolt assembly to the project
*MaterialApi* | [**add_cross_section**](docs/MaterialApi.md#add_cross_section) | **POST** /api/1/projects/{projectId}/materials/cross-sections | Add cross section to the project
*MaterialApi* | [**add_material_bolt_grade**](docs/MaterialApi.md#add_material_bolt_grade) | **POST** /api/1/projects/{projectId}/materials/bolt-grade | Add material to the project
*MaterialApi* | [**add_material_concrete**](docs/MaterialApi.md#add_material_concrete) | **POST** /api/1/projects/{projectId}/materials/concrete | Add material to the project
*MaterialApi* | [**add_material_steel**](docs/MaterialApi.md#add_material_steel) | **POST** /api/1/projects/{projectId}/materials/steel | Add material to the project
*MaterialApi* | [**add_material_weld**](docs/MaterialApi.md#add_material_weld) | **POST** /api/1/projects/{projectId}/materials/welding | Add material to the project
*MaterialApi* | [**get_all_materials**](docs/MaterialApi.md#get_all_materials) | **GET** /api/1/projects/{projectId}/materials | Get materials which are used in the project projectId
*MaterialApi* | [**get_blot_grade_materials**](docs/MaterialApi.md#get_blot_grade_materials) | **GET** /api/1/projects/{projectId}/materials/bolt-grade | Get materials which are used in the project projectId
*MaterialApi* | [**get_bolt_assemblies**](docs/MaterialApi.md#get_bolt_assemblies) | **GET** /api/1/projects/{projectId}/materials/bolt-assemblies | Get bolt assemblies which are used in the project projectId
*MaterialApi* | [**get_concrete_materials**](docs/MaterialApi.md#get_concrete_materials) | **GET** /api/1/projects/{projectId}/materials/concrete | Get materials which are used in the project projectId
*MaterialApi* | [**get_cross_sections**](docs/MaterialApi.md#get_cross_sections) | **GET** /api/1/projects/{projectId}/materials/cross-sections | Get cross sections which are used in the project projectId
*MaterialApi* | [**get_steel_materials**](docs/MaterialApi.md#get_steel_materials) | **GET** /api/1/projects/{projectId}/materials/steel | Get materials which are used in the project projectId
*MaterialApi* | [**get_welding_materials**](docs/MaterialApi.md#get_welding_materials) | **GET** /api/1/projects/{projectId}/materials/welding | Get materials which are used in the project projectId
*MemberApi* | [**get_all_member_data**](docs/MemberApi.md#get_all_member_data) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/members | Get information about all members in the connection
*MemberApi* | [**get_member_data**](docs/MemberApi.md#get_member_data) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/members/{memberId} | Get information about the requires member in the connection
*MemberApi* | [**update_member**](docs/MemberApi.md#update_member) | **PUT** /api/1/projects/{projectId}/connections/{connectionId}/members/{memberId} | Update the member in the connection by newMemberData
*ParameterApi* | [**evaluate_expression**](docs/ParameterApi.md#evaluate_expression) | **POST** /api/1/projects/{projectId}/connections/{connectionId}/evaluate-expression | Evaluate the expression and return the result
*ParameterApi* | [**get_parameters**](docs/ParameterApi.md#get_parameters) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/parameters | Get all parameters which are defined for projectId and connectionId
*ParameterApi* | [**update_parameters**](docs/ParameterApi.md#update_parameters) | **PUT** /api/1/projects/{projectId}/connections/{connectionId}/parameters | Update parameters for the connection connectionId in the project projectId by values passed in parameters
*PresentationApi* | [**get_data_scene3_d**](docs/PresentationApi.md#get_data_scene3_d) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/presentation | Returns data for scene3D
*ProjectApi* | [**close_project**](docs/ProjectApi.md#close_project) | **GET** /api/1/projects/{projectId}/close | Close the project. Needed for releasing resources in the service.
*ProjectApi* | [**connect_client**](docs/ProjectApi.md#connect_client) | **GET** /api/1/connect-client | Connect a client to the ConnectionRestApi service. Method returns a unique identifier of the client.
*ProjectApi* | [**download_project**](docs/ProjectApi.md#download_project) | **GET** /api/1/projects/{projectId}/download | Download the actual ideacon project from the service. It includes alle changes which were made by previous API calls.
*ProjectApi* | [**get_active_projects**](docs/ProjectApi.md#get_active_projects) | **GET** /api/1/projects | Get the list of projects in the service which were opened by the client which was connected by M:IdeaStatiCa.ConnectionRestApi.Controllers.ProjectController.ConnectClient
*ProjectApi* | [**get_project_data**](docs/ProjectApi.md#get_project_data) | **GET** /api/1/projects/{projectId}/project-data | Get data of the project.
*ProjectApi* | [**get_setup**](docs/ProjectApi.md#get_setup) | **GET** /api/1/projects/{projectId}/connection-setup | Get setup from project
*ProjectApi* | [**import_iom**](docs/ProjectApi.md#import_iom) | **POST** /api/1/projects/import-iom-file | Creates an IDEA Connection project. IOM is passed in the body of the request.
*ProjectApi* | [**import_iom_container**](docs/ProjectApi.md#import_iom_container) | **POST** /api/1/projects/import-iom | Creates an IDEA Connection project from model (model and results)
*ProjectApi* | [**open_project**](docs/ProjectApi.md#open_project) | **POST** /api/1/projects/open | Open ideacon project which is passed in the body of the request  TODO - should be the parameter of the method
*ProjectApi* | [**update_from_iom**](docs/ProjectApi.md#update_from_iom) | **POST** /api/1/projects/{projectId}/update-iom-file | Update an IDEA Connection project based on OpenModelContainer (model and results). IOM is passed in the body of the request.
*ProjectApi* | [**update_from_iom_container**](docs/ProjectApi.md#update_from_iom_container) | **POST** /api/1/projects/{projectId}/update-iom | Update an IDEA Connection project by model (model and results)
*ProjectApi* | [**update_setup**](docs/ProjectApi.md#update_setup) | **PUT** /api/1/projects/{projectId}/connection-setup | Update setup of the project
*ProjectApi* | [**upload_idea_con**](docs/ProjectApi.md#upload_idea_con) | **POST** /api/1/projects/upload-ideacon | Open ideacon project from ideaConFile
*ReportApi* | [**generate_pdf**](docs/ReportApi.md#generate_pdf) | **GET** /api/1/projects/{projectId}/reports/{connectionId}/pdf | Generates report for projectId and connectionId
*ReportApi* | [**generate_word**](docs/ReportApi.md#generate_word) | **GET** /api/1/projects/{projectId}/reports/{connectionId}/word | Generates report for projectId and connectionId
*TemplateApi* | [**apply_template**](docs/TemplateApi.md#apply_template) | **POST** /api/1/projects/{projectId}/connections/{connectionId}/apply-template | Apply the connection template applyTemplateParam on the connection connectionId in the project projectId
*TemplateApi* | [**create_con_template**](docs/TemplateApi.md#create_con_template) | **GET** /api/1/projects/{projectId}/connections/{connectionId}/get-template | Create a template for the connection connectionId in the project projectId
*TemplateApi* | [**get_default_template_mapping**](docs/TemplateApi.md#get_default_template_mapping) | **POST** /api/1/projects/{projectId}/connections/{connectionId}/get-default-mapping | Get the default mappings for the application of the connection template passed in templateToApply  on connectionId in the project projectId
*VersionApi* | [**get_version**](docs/VersionApi.md#get_version) | **GET** /api/1/version | 


## Documentation For Models

 - [Anchor3D](docs/Anchor3D.md)
 - [AnchorGrid](docs/AnchorGrid.md)
 - [AnchorType](docs/AnchorType.md)
 - [ArcSegment3D](docs/ArcSegment3D.md)
 - [BasePlate3D](docs/BasePlate3D.md)
 - [BaseTemplateConversion](docs/BaseTemplateConversion.md)
 - [Beam](docs/Beam.md)
 - [BeamData](docs/BeamData.md)
 - [BendData](docs/BendData.md)
 - [BoltGrid](docs/BoltGrid.md)
 - [BoltShearType](docs/BoltShearType.md)
 - [BucklingRes](docs/BucklingRes.md)
 - [CheckMember](docs/CheckMember.md)
 - [CheckResAnchor](docs/CheckResAnchor.md)
 - [CheckResBolt](docs/CheckResBolt.md)
 - [CheckResConcreteBlock](docs/CheckResConcreteBlock.md)
 - [CheckResPlate](docs/CheckResPlate.md)
 - [CheckResSummary](docs/CheckResSummary.md)
 - [CheckResWeld](docs/CheckResWeld.md)
 - [CheckSection](docs/CheckSection.md)
 - [CombiInput](docs/CombiInput.md)
 - [ConAnalysisTypeEnum](docs/ConAnalysisTypeEnum.md)
 - [ConCalculationParameter](docs/ConCalculationParameter.md)
 - [ConConnection](docs/ConConnection.md)
 - [ConLoadEffect](docs/ConLoadEffect.md)
 - [ConLoadEffectMemberLoad](docs/ConLoadEffectMemberLoad.md)
 - [ConLoadEffectPositionEnum](docs/ConLoadEffectPositionEnum.md)
 - [ConLoadEffectSectionLoad](docs/ConLoadEffectSectionLoad.md)
 - [ConLoadingOptions](docs/ConLoadingOptions.md)
 - [ConMember](docs/ConMember.md)
 - [ConMissingWeld](docs/ConMissingWeld.md)
 - [ConMprlCrossSection](docs/ConMprlCrossSection.md)
 - [ConMprlElement](docs/ConMprlElement.md)
 - [ConOperation](docs/ConOperation.md)
 - [ConProductionCost](docs/ConProductionCost.md)
 - [ConProject](docs/ConProject.md)
 - [ConProjectData](docs/ConProjectData.md)
 - [ConResultSummary](docs/ConResultSummary.md)
 - [ConTemplateApplyParam](docs/ConTemplateApplyParam.md)
 - [ConTemplateMappingGetParam](docs/ConTemplateMappingGetParam.md)
 - [ConcreteBlock](docs/ConcreteBlock.md)
 - [ConcreteBlockData](docs/ConcreteBlockData.md)
 - [ConcreteSetup](docs/ConcreteSetup.md)
 - [ConeBreakoutCheckType](docs/ConeBreakoutCheckType.md)
 - [ConnectionCheckRes](docs/ConnectionCheckRes.md)
 - [ConnectionData](docs/ConnectionData.md)
 - [ConnectionPoint](docs/ConnectionPoint.md)
 - [ConnectionSetup](docs/ConnectionSetup.md)
 - [CrossSection](docs/CrossSection.md)
 - [CrtCompCheckIS](docs/CrtCompCheckIS.md)
 - [CutBeamByBeamData](docs/CutBeamByBeamData.md)
 - [CutData](docs/CutData.md)
 - [CutMethod](docs/CutMethod.md)
 - [CutOrientation](docs/CutOrientation.md)
 - [CutPart](docs/CutPart.md)
 - [DappedEnd](docs/DappedEnd.md)
 - [DesignMember](docs/DesignMember.md)
 - [DetailCombination](docs/DetailCombination.md)
 - [DetailLoadCase](docs/DetailLoadCase.md)
 - [DistanceComparison](docs/DistanceComparison.md)
 - [DrawData](docs/DrawData.md)
 - [EPurpose](docs/EPurpose.md)
 - [Element1D](docs/Element1D.md)
 - [Element2D](docs/Element2D.md)
 - [FatigueTypeOfPrestressingSteel](docs/FatigueTypeOfPrestressingSteel.md)
 - [FoldedPlateData](docs/FoldedPlateData.md)
 - [HingeElement1D](docs/HingeElement1D.md)
 - [IGroup](docs/IGroup.md)
 - [ISDModel](docs/ISDModel.md)
 - [IdeaParameter](docs/IdeaParameter.md)
 - [IdeaParameterUpdate](docs/IdeaParameterUpdate.md)
 - [InitialImperfectionOfPoint](docs/InitialImperfectionOfPoint.md)
 - [Line](docs/Line.md)
 - [LineSegment3D](docs/LineSegment3D.md)
 - [LineSupportSegment](docs/LineSupportSegment.md)
 - [LoadCase](docs/LoadCase.md)
 - [LoadEffectData](docs/LoadEffectData.md)
 - [LoadGroup](docs/LoadGroup.md)
 - [LoadInPoint](docs/LoadInPoint.md)
 - [LoadOnLine](docs/LoadOnLine.md)
 - [LoadOnSurface](docs/LoadOnSurface.md)
 - [Loading](docs/Loading.md)
 - [LoadingType](docs/LoadingType.md)
 - [MatConcrete](docs/MatConcrete.md)
 - [MatPrestressSteel](docs/MatPrestressSteel.md)
 - [MatReinforcement](docs/MatReinforcement.md)
 - [MatSteel](docs/MatSteel.md)
 - [MatWelding](docs/MatWelding.md)
 - [MaterialDuct](docs/MaterialDuct.md)
 - [Member](docs/Member.md)
 - [Member1D](docs/Member1D.md)
 - [Member2D](docs/Member2D.md)
 - [MemberType](docs/MemberType.md)
 - [MemoryStream](docs/MemoryStream.md)
 - [MessageNumber](docs/MessageNumber.md)
 - [OkObjectResult](docs/OkObjectResult.md)
 - [OpenElementId](docs/OpenElementId.md)
 - [OpenMessage](docs/OpenMessage.md)
 - [OpenMessages](docs/OpenMessages.md)
 - [OpenModel](docs/OpenModel.md)
 - [OpenModelContainer](docs/OpenModelContainer.md)
 - [OpenModelResult](docs/OpenModelResult.md)
 - [Opening](docs/Opening.md)
 - [ParameterData](docs/ParameterData.md)
 - [PatchDevice](docs/PatchDevice.md)
 - [PlateData](docs/PlateData.md)
 - [Point2D](docs/Point2D.md)
 - [Point3D](docs/Point3D.md)
 - [PointLoadOnLine](docs/PointLoadOnLine.md)
 - [PointOnLine3D](docs/PointOnLine3D.md)
 - [PointSupportNode](docs/PointSupportNode.md)
 - [PolyLine2D](docs/PolyLine2D.md)
 - [PolyLine3D](docs/PolyLine3D.md)
 - [Polygon2D](docs/Polygon2D.md)
 - [RebarGeneral](docs/RebarGeneral.md)
 - [RebarShape](docs/RebarShape.md)
 - [RebarSingle](docs/RebarSingle.md)
 - [RebarStirrups](docs/RebarStirrups.md)
 - [ReferenceElement](docs/ReferenceElement.md)
 - [Region2D](docs/Region2D.md)
 - [Region3D](docs/Region3D.md)
 - [ReinfBarSurface](docs/ReinfBarSurface.md)
 - [ReinforcedBar](docs/ReinforcedBar.md)
 - [ReinforcedCrossSection](docs/ReinforcedCrossSection.md)
 - [Reinforcement](docs/Reinforcement.md)
 - [ResultClass](docs/ResultClass.md)
 - [ResultLocalSystemType](docs/ResultLocalSystemType.md)
 - [ResultOnMember](docs/ResultOnMember.md)
 - [ResultOnMembers](docs/ResultOnMembers.md)
 - [ResultType](docs/ResultType.md)
 - [RigidLink](docs/RigidLink.md)
 - [Segment2D](docs/Segment2D.md)
 - [Selected](docs/Selected.md)
 - [SelectedType](docs/SelectedType.md)
 - [Settlement](docs/Settlement.md)
 - [SolidBlock3D](docs/SolidBlock3D.md)
 - [Span](docs/Span.md)
 - [Stirrup](docs/Stirrup.md)
 - [StrainLoadOnLine](docs/StrainLoadOnLine.md)
 - [SubStructure](docs/SubStructure.md)
 - [SurfaceSupport3D](docs/SurfaceSupport3D.md)
 - [Taper](docs/Taper.md)
 - [TemperatureCurve2D](docs/TemperatureCurve2D.md)
 - [TemperatureLoadOnLine](docs/TemperatureLoadOnLine.md)
 - [TemplateConversions](docs/TemplateConversions.md)
 - [Tendon](docs/Tendon.md)
 - [TendonBar](docs/TendonBar.md)
 - [TendonBarType](docs/TendonBarType.md)
 - [TendonDuct](docs/TendonDuct.md)
 - [Text](docs/Text.md)
 - [TextPosition](docs/TextPosition.md)
 - [ThermalConductivityState](docs/ThermalConductivityState.md)
 - [ThermalExpansionState](docs/ThermalExpansionState.md)
 - [ThermalSpecificHeatState](docs/ThermalSpecificHeatState.md)
 - [ThermalStrainState](docs/ThermalStrainState.md)
 - [ThermalStressStrainState](docs/ThermalStressStrainState.md)
 - [UploadIdeaConRequest](docs/UploadIdeaConRequest.md)
 - [ValidationType](docs/ValidationType.md)
 - [Vector3D](docs/Vector3D.md)
 - [Wall](docs/Wall.md)
 - [WeldData](docs/WeldData.md)
 - [WeldEvaluation](docs/WeldEvaluation.md)
 - [WeldType](docs/WeldType.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




