# coding: utf-8

"""
    Connection Rest API 1.0

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from connection_restapi_client_poc.models.fatigue_type_of_prestressing_steel import FatigueTypeOfPrestressingSteel
from connection_restapi_client_poc.models.point2_d import Point2D
from connection_restapi_client_poc.models.reference_element import ReferenceElement
from connection_restapi_client_poc.models.tendon_bar_type import TendonBarType
from connection_restapi_client_poc.models.tendon_duct import TendonDuct
from typing import Optional, Set
from typing_extensions import Self

class TendonBar(BaseModel):
    """
    Tendon bar
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="Tendon Id")
    tendon_type: Optional[TendonBarType] = Field(default=None, alias="tendonType")
    point: Optional[Point2D] = None
    material: Optional[ReferenceElement] = None
    prestressing_order: Optional[StrictInt] = Field(default=None, description="order of tendon prestessing", alias="prestressingOrder")
    num_strands_in_tendon: Optional[StrictInt] = Field(default=None, description="number of ropes in tendon", alias="numStrandsInTendon")
    prestress_reinforcement_type: Optional[FatigueTypeOfPrestressingSteel] = Field(default=None, alias="prestressReinforcementType")
    phase: Optional[StrictInt] = Field(default=None, description="Phase")
    tendon_duct: Optional[TendonDuct] = Field(default=None, alias="tendonDuct")
    __properties: ClassVar[List[str]] = ["id", "tendonType", "point", "material", "prestressingOrder", "numStrandsInTendon", "prestressReinforcementType", "phase", "tendonDuct"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TendonBar from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of point
        if self.point:
            _dict['point'] = self.point.to_dict()
        # override the default output from pydantic by calling `to_dict()` of material
        if self.material:
            _dict['material'] = self.material.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tendon_duct
        if self.tendon_duct:
            _dict['tendonDuct'] = self.tendon_duct.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TendonBar from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "tendonType": obj.get("tendonType"),
            "point": Point2D.from_dict(obj["point"]) if obj.get("point") is not None else None,
            "material": ReferenceElement.from_dict(obj["material"]) if obj.get("material") is not None else None,
            "prestressingOrder": obj.get("prestressingOrder"),
            "numStrandsInTendon": obj.get("numStrandsInTendon"),
            "prestressReinforcementType": obj.get("prestressReinforcementType"),
            "phase": obj.get("phase"),
            "tendonDuct": TendonDuct.from_dict(obj["tendonDuct"]) if obj.get("tendonDuct") is not None else None
        })
        return _obj


